Home | Download | Screen shots | Discussion | Documentation
--- | --- | --- | --- | ---

- Main Page
- Namespaces
- Classes
- Files
- Examples

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | Private Member Functions
openvrml::normal_node Class Reference

Abstract base class for normal nodes. More...

`#include <openvrml/node.h>`

Inheritance diagram for openvrml::normal_node:
[legend]

List of all members.

## Public Member Functions

virtual | ~normal_node ()=0 throw ()
| Destroy.
const std::vector< vec3f > & | vector () const throw ()
| Get the array of normal vectors.

## Protected Member Functions

| normal_node (const node_type &type, const boost::shared_ptr< openvrml::scope > &scope) throw ()
| Construct.

## Private Member Functions

virtual normal_node * | to_normal () throw ()
| Cast to a `normal_node`.
virtual const std::vector < vec3f > & | do_vector () const =0 throw ()
| Get the array of normal vectors.

## Detailed Description

Abstract base class for normal nodes.

## Constructor & Destructor Documentation

openvrml::normal_node::~normal_node | ( |  | ) | throw ()`[pure virtual]`

Destroy.

openvrml::normal_node::normal_node | ( | const node_type & | type,
|  | const boost::shared_ptr< openvrml::scope > & | scope
| ) |  | throw ()`[protected]`

Construct.

Parameters:

  [in] | type | the `node_type` associated with the node.
  [in] | scope | the `scope` the node belongs to.

## Member Function Documentation

const std::vector< openvrml::vec3f > & openvrml::normal_node::vector | ( |  | ) | const throw ()

Get the array of normal vectors.

This function delegates to `do_vector`.

Returns:
  the array of normal vectors.

openvrml::normal_node * openvrml::normal_node::to_normal | ( |  | ) | throw ()`[private, virtual]`

Cast to a `normal_node`.

Returns:
  a pointer to this `normal_node`.

Reimplemented from openvrml::node.

const std::vector< openvrml::vec3f > & openvrml::normal_node::do_vector | ( |  | ) | const throw ()`[private, pure virtual]`

Get the array of normal vectors.

Returns:
  the array of normal vectors.